<?php
include("helpCommon.php");
helpHeader();
?>
<H3>Work Order Entry</H3>
You use this screen to enter new work orders. This help file explains the fields and how to fill them in. Fields marked '**' are only entered if your security level is greater than seclvlAddAssignWO, (usually 5).
<BR>
<BR>
<H4>Product</H4>
Select the product this work order is to be associated with.

<H4>Account</H4>
Select the account (if any) that is specific to this work order.

<H4>Responsible **</H4>
Select the person responsible to complete the work order.

<H4>Deadline **</H4>
The time by which this work order should be completed. The small
button next to this field brings up a GUI calendar which you can
use to select a date.

<H4>Est. Start **</H4>
The date you plan to start work on this work order. The small
button next to this field brings up a GUI calendar which you can
use to select a date.

<H4>Est. End **</H4>
The date you plan to resolvethis work order. The small
button next to this field brings up a GUI calendar which you can
use to select a date.

<H4>Est Hours **</H4>
An estimate of how long it wiil take to resolve the work order.

<H4>Reported Version</H4>
The affected version of the system.

<H4>Priority **</H4>
The priority of the work order.

<H4>Severity **</H4>
The severity of the work order.

<H4>Contact</H4>
If there is an individual who may be contacted for more
information regarding this work order, put their name/organisation here.

<H4>Contact Phone</H4>
If you have a phone number for the contact person, enter it here.

<H4>Summary</H4>
A one line description of the problem. Ideally, this will be
about 60 characters and outline the problem as specfifically as
possible. An example is given here to indicate how you should use this
field. Imagine the following problem description.

<pre>
Description

The 'Help' link on the 'Upcoming attractions' page
(/attractions/upcoming/index.html) points to
/help/att-upc-help.html, which does not exist.
</pre>

<UL>
  <LI>Summary: Problem with web site<BR>

	- this is not a very good summary. It doesn't indicate what
	the problem is, where on the web site it is, or what type of
	problem it is.</LI>

  <LI>Summary: Broken link on web site<BR>

	- better, in that it indicates what the problem is, but it
	still does not indicate where or why the link is broken.</LI>

  <LI>Summary: Upcoming attractions help link broken (/attractions/upcoming/)<BR>

	- Good. We now know where the broken link is and that it is
	the help link.

  <LI>Summary: Upc. Attr. help link broken (/help/att-upc-help.html not found)<BR>

	- good as well. This time we also know the name of the file
	that is not found.</LI>

</UL>

<H4>Notes</H4>
This section is for any information about the work order that is not
related to the description. For example, if you wrote a test harness
that automatically raised work orders when tests fail, you might put
the text:<BR>

<pre>
Generated by automatic test harness v1.2 Started at 11:45:32 23/01/2001
</pre>

<H4>Description</H4>

This is where you put the detail of the problem. Include as
much information as you think is relevant. If you know what needs to
be done to solve the problem, state it here; otherwise, state as much
as you know about the problem. How/when it occurs. Can it be
reproduced? Has a workaround been put in place? How many customers
does it affect, and how. What attempts have been made to resolve the
problem. What part of the system does the fault affect.

<?php
helpFooter();
?>
